//==============================================================================
//
//  Tinker Bell (MapHack for WinMine 2000 Pro and XP Pro) (Korean version only)
//
// Writer : Yeori (Sun Kyung-Ryul)
// Date   : June 30th, 2003.
// e-mail : alphamcu@hanmail.net
// web    : www.zap.pe.kr
//
// comments : no copyright and no restriction to use and distribute. :)
//
// Change log : July 1st, 2003. - Support WinMine for Windows XP Pro.
//
//==============================================================================

#include "stdafx.h"
#include "TinkerBell.h"
#include "TinkerBellDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//==============================================================================
//  Global variables
//
#define BUILD_FOR_2000_PRO	1
#define BUILD_FOR_XP_PRO	2
#define BUILD_TYPE			BUILD_FOR_2000_PRO	// choose the build type you want.
												// default : windows 2000 pro.

#if (BUILD_TYPE==BUILD_FOR_2000_PRO)
#define ADDR_SIZE_X		0x010056f8 // for windows 2000 pro
#define ADDR_SIZE_Y		0x01005a68
#define ADDR_MAP		0x01005720
#else
#define ADDR_SIZE_X		0x01005334 // for windows xp pro
#define ADDR_SIZE_Y		0x01005338
#define ADDR_MAP		0x01005361
#endif

#define MARK_GROUP		0x10 // unused
#define MARK_MINE_EXIST	0x80
#define MARK_SHOWED		0x40 // unused

#define MARK_BLOCK		0x0f
#define MARK_MINE		0x0a
#define MARK_X_MINE		0x0b
#define MARK_RED_MINE	0x0c
#define MARK_QUESTION	0x0d
#define MARK_FLAG		0x0e

#define IS_MINE(ITEM)	(ITEM & MARK_MINE_EXIST) // return nonzero value if ITEM is mine.

#define MAP_MAX_X	32 // max 30 and two group marks
#define MAP_MAX_Y	24 // max 24
#define MAP_SIZE	(MAP_MAX_X*MAP_MAX_Y)

static BYTE			btMineMap[MAP_SIZE];

static HINSTANCE	hInstance	= NULL;

static TCHAR szClassName[]	= TEXT(" ã");
static TCHAR szWindowName[]	= TEXT(" ã");


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTinkerBellDlg dialog



CTinkerBellDlg::CTinkerBellDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTinkerBellDlg::IDD, pParent)
	, m_WidthEdit(0)
	, m_HeightEdit(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTinkerBellDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_WIDTH_EDIT, m_WidthEdit);
	DDX_Text(pDX, IDC_HEIGHT_EDIT, m_HeightEdit);
}

BEGIN_MESSAGE_MAP(CTinkerBellDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_ON_BUTTON, OnBnClickedOnButton)
	ON_BN_CLICKED(IDC_OFF_BUTTON, OnBnClickedOffButton)
	ON_BN_CLICKED(IDC_ABOUT_BUTTON, OnBnClickedAboutButton)
END_MESSAGE_MAP()


// CTinkerBellDlg message handlers

BOOL CTinkerBellDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTinkerBellDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTinkerBellDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTinkerBellDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTinkerBellDlg::OnBnClickedOk()
{
	// TODO: nothing. ^^
	OnOK();
}

BOOL CTinkerBellDlg::GetMatrixInfo(HANDLE hProcess)
{
	BOOL bResult = FALSE;

	bResult = ReadProcessMemory(hProcess, (LPCVOID)ADDR_SIZE_X, &m_WidthEdit, sizeof(DWORD), 0);
	if(!bResult) { goto $end; }
	bResult = ReadProcessMemory(hProcess, (LPCVOID)ADDR_SIZE_Y, &m_HeightEdit, sizeof(DWORD), 0);
	if(!bResult) { goto $end; }

	UpdateData(FALSE);
	//
	bResult = TRUE;
$end:
	return bResult;
}

BOOL CTinkerBellDlg::GetHandles(HWND *pWndHandle, HANDLE *pInstanceHandle)
{
	BOOL bResult = FALSE;
	DWORD dwProcessID = 0;

	*pWndHandle = ::FindWindow(szClassName, szWindowName);
	if(!(*pWndHandle)) { 
		MessageBox(TEXT("Sorry! There is no WinMine."), TEXT(" Tinker Bell"), MB_ICONSTOP);
		goto $end;
	}

	GetWindowThreadProcessId(*pWndHandle, &dwProcessID);
	*pInstanceHandle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ, FALSE, dwProcessID);
	if(!(*pInstanceHandle)) { goto $end; }

	bResult = TRUE;
$end:
	return bResult;
}

void CTinkerBellDlg::OnBnClickedOnButton()
{
	BOOL bResult = FALSE;
	HWND hWnd = NULL;
	HANDLE hProcess = NULL;

	// get handle
	bResult = GetHandles(&hWnd, &hProcess);
	if(!bResult) { goto $end; }

	// get matrix info
	bResult = GetMatrixInfo(hProcess);
	if(!bResult) { goto $end; }

	// read map
	bResult = ReadProcessMemory(hProcess, (LPCVOID)ADDR_MAP, &btMineMap[0], MAP_SIZE, 0);
	if(!bResult) { goto $end; }

	// reset map
	for(DWORD i=0; i<MAP_SIZE; i++) {
		if(IS_MINE(btMineMap[i])) {
			if((btMineMap[i]&0x0f) == MARK_QUESTION
				|| (btMineMap[i]&0x0f) == MARK_FLAG
				|| (btMineMap[i]&0x0f) == MARK_X_MINE ) {
				btMineMap[i] &= 0xf0;
				btMineMap[i] |= MARK_X_MINE;
			} else if((btMineMap[i]&0x0f) != MARK_RED_MINE) {
				btMineMap[i] &= 0xf0;
				btMineMap[i] |= MARK_MINE;
			}
		}
	}

	// rewrite map data
	bResult = WriteProcessMemory(hProcess, (LPVOID)ADDR_MAP, &btMineMap[0], MAP_SIZE, 0);
	if(!bResult) { goto $end; }

	// redraw grid
	::InvalidateRect(hWnd, NULL, TRUE);

$end:
	if(hProcess) {
		CloseHandle(hProcess);
	}
}

void CTinkerBellDlg::OnBnClickedOffButton()
{
	BOOL bResult = FALSE;
	HWND hWnd = NULL;
	HANDLE hProcess = NULL;

	// get handle
	bResult = GetHandles(&hWnd, &hProcess);
	if(!bResult) { goto $end; }

	// get matrix info
	bResult = GetMatrixInfo(hProcess);
	if(!bResult) { goto $end; }

	// read map
	bResult = ReadProcessMemory(hProcess, (LPCVOID)ADDR_MAP, &btMineMap[0], MAP_SIZE, 0);
	if(!bResult) { goto $end; }

	// reset map
	for(DWORD i=0; i<MAP_SIZE; i++) {
		if(IS_MINE(btMineMap[i])) {
			if((btMineMap[i] & 0x0f) == MARK_X_MINE) {
				btMineMap[i] &= 0xf0;
				btMineMap[i] |= MARK_FLAG;
			} else if ((btMineMap[i] & 0x0f) == MARK_MINE) {
				btMineMap[i] &= 0xf0;
				btMineMap[i] |= MARK_BLOCK;
			}
		}
	}

	// rewrite map data
	bResult = WriteProcessMemory(hProcess, (LPVOID)ADDR_MAP, &btMineMap[0], MAP_SIZE, 0);
	if(!bResult) { goto $end; }

	// redraw grid
	::InvalidateRect(hWnd, NULL, TRUE);

$end:
	if(hProcess) {
		CloseHandle(hProcess);
	}
}

void CTinkerBellDlg::OnBnClickedAboutButton()
{
	// TODO: nothing. ^^
	CAboutDlg dlg;
	dlg.DoModal();
}
